#
from netgen.meshing import *
from netgen.csg import *
from ngsolve import ngsglobals
ngsglobals.msg_level = 2
#
import netgen.meshing as meshing
from netgen.meshing import MeshingParameters
from netgen.csg import *
from netgen.NgOCC import *
import numpy as np

geo = CSGeometry()
sphere = Sphere(Pnt(0,0,0),1)

geo1 = LoadOCCGeometry('./test.STEP');
geo1.Heal()
m1 = geo1.GenerateMesh()
nfaces = m1.GetNFaceDescriptors()
for j in range(0,nfaces):
    m1.SetBCName(j,'scatterer')

m1.Export('./test.stl','STL Format') # looks ok!

x0 = -0.011817;
y0 = -38.122429; 
z0 = -0.004375;
# *********************************************************************
Rext = 65.
# generate sphere and mesh it
geo2 = CSGeometry()
geo2.Add (Sphere (Pnt(x0,y0,z0), Rext))
m2 = geo2.GenerateMesh ()
mesh = Mesh()
#merge.py:
# a face-descriptor stores properties associated with a set of surface elements
# bc .. boundary condition marker,
# domin/domout .. domain-number in front/back of surface elements (0 = void),
# surfnr .. number of the surface described by the face-descriptor

fd_outside = mesh.Add (FaceDescriptor(bc=1,domin=1,surfnr=1))
fd_inside = mesh.Add (FaceDescriptor(bc=2,domin=2,domout=1,surfnr=2))
# copy all boundary points from first mesh to new mesh.
# pmap1 maps point-numbers from old to new mesh

pmap1 = { }
for e in m1.Elements2D():
    for v in e.vertices:
        if (v not in pmap1):
            pmap1[v] = mesh.Add (m1[v])


# copy surface elements from first mesh to new mesh
# we have to map point-numbers:

for e in m1.Elements2D():
    mesh.Add (Element2D (fd_outside, [pmap1[v] for v in e.vertices]))



# same for the second mesh:

pmap2 = { }
for e in m2.Elements2D():
    for v in e.vertices:
        if (v not in pmap2):
            pmap2[v] = mesh.Add (m2[v])

for e in m2.Elements2D():
    mesh.Add (Element2D (fd_inside, [pmap2[v] for v in e.vertices]))


print ("******************")
print ("** merging done **")
print ("******************")
mesh.Export('combined.stl','STL Format')
mesh.GenerateVolumeMesh()
mesh.Save ("newmesh.vol")